// ShellExtClassFactory.cpp: CShellExtClassFactory NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ShellExtension.h"
#include "ShellExtClassFactory.h"

extern UINT      g_cRefThisDll;    // Reference count of this DLL.
extern HINSTANCE g_hmodThisDll;    // Handle to this DLL itself.
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CShellExtClassFactory::CShellExtClassFactory()
{
  m_cRef = 0L;
  g_cRefThisDll++;
}

CShellExtClassFactory::~CShellExtClassFactory()
{
  g_cRefThisDll--;
}

STDMETHODIMP CShellExtClassFactory::QueryInterface(REFIID riid, LPVOID FAR *ppv)
{
  *ppv = NULL;
  if (IsEqualIID(riid, IID_IUnknown) || IsEqualIID(riid, IID_IClassFactory)) {
    *ppv = (LPCLASSFACTORY)this;
    AddRef();
    return NOERROR;
  }
  return E_NOINTERFACE;
}

STDMETHODIMP_(ULONG) CShellExtClassFactory::AddRef()
{
  return ++m_cRef;
}

STDMETHODIMP_(ULONG) CShellExtClassFactory::Release()
{
  if (--m_cRef)
    return m_cRef;
  delete this;
  return 0L;
}

STDMETHODIMP CShellExtClassFactory::CreateInstance(LPUNKNOWN pUnkOuter, REFIID riid, void** ppvObj)
{
  *ppvObj = NULL;
  if (pUnkOuter) {
    return CLASS_E_NOAGGREGATION;
  }

  CShellExtension *pShellExt = new CShellExtension();
  if (!pShellExt) {
    return E_OUTOFMEMORY;
  }
  return pShellExt->QueryInterface(riid, ppvObj);
}

STDMETHODIMP CShellExtClassFactory::LockServer(BOOL fLock)
{
  return NOERROR;
}