// ShellExtension.cpp: CShellExtension NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ShellExtension.h"

extern UINT      g_cRefThisDll;    // Reference count of this DLL.
extern HINSTANCE g_hmodThisDll;    // Handle to this DLL itself.

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CShellExtension::CShellExtension()
{
  m_cRef = 0L;
  m_pDataObj = NULL;
  g_cRefThisDll++;
}

CShellExtension::~CShellExtension()
{
  if (m_pDataObj)
    m_pDataObj->Release();
  g_cRefThisDll--;
}

STDMETHODIMP CShellExtension::QueryInterface(REFIID riid, LPVOID* ppv)
{
  *ppv = NULL;
  if (IsEqualIID(riid, IID_IShellExtInit) || IsEqualIID(riid, IID_IUnknown)) {
      *ppv = (LPSHELLEXTINIT)this;
  } else if (IsEqualIID(riid, IID_IContextMenu)) {
      *ppv = (LPCONTEXTMENU)this;
  }
  if (*ppv) {
    AddRef();
    return NOERROR;
  }

  return E_NOINTERFACE;
}

STDMETHODIMP_(ULONG) CShellExtension::AddRef() {
  return ++m_cRef;
}

STDMETHODIMP_(ULONG) CShellExtension::Release() {
  if (--m_cRef)
    return m_cRef;
  delete this;
  return 0L;
}

STDMETHODIMP CShellExtension::Initialize( LPCITEMIDLIST pidlFolder,
                                          LPDATAOBJECT pDataObj,
                                          HKEY hkeyProgID )
{
  if (m_pDataObj)
    m_pDataObj->Release();

  if (pDataObj) {
    m_pDataObj = pDataObj;
    pDataObj->AddRef();
  }

  return NOERROR;
}

STDMETHODIMP CShellExtension::QueryContextMenu( HMENU hmenu,
                                                UINT indexMenu,
                                                UINT idCmdFirst,
                                                UINT idCmdLast,
                                                UINT uFlags )
{
  static char szMenu1[64] = "KageHinata";
  static char szSubMenu1[64] = "kEÍ";
  static char szSubMenu2[64] = "EWJ";
  UINT idCmd = idCmdFirst;
  CHAR szFileName[MAX_PATH + 1] = "";
  BOOL fDec = FALSE;

//  CHAR buff[256];
//  MessageBox(NULL, _itoa(uFlags & 0x000F, buff, 16), "Check", MB_OK);

  if (((uFlags & 0x000F) == CMF_NORMAL) ||
      ((uFlags & 0x000F) == CMF_VERBSONLY) ||
      ((uFlags & 0x000F) == CMF_EXPLORE)) { // Notice: CMF_NORMAL=0
    FORMATETC fmt = { CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
    STGMEDIUM stg = { TYMED_HGLOBAL };
    HDROP hDrop;

    if (FAILED(m_pDataObj->GetData(&fmt, &stg)))
      return E_INVALIDARG;

    // HDROP擾
    hDrop = (HDROP)GlobalLock(stg.hGlobal);

    // t@C`FbN
    UINT uNumFiles = DragQueryFile(hDrop, 0xFFFFFFFF, NULL, 0);
    if (uNumFiles == 0) {
      GlobalUnlock(stg.hGlobal);
      ReleaseStgMedium(&stg);
      return E_INVALIDARG;
    } else if (uNumFiles == 1) {
      if (DragQueryFile(hDrop, 0, szFileName, MAX_PATH) > 0) {
        HANDLE hFind = INVALID_HANDLE_VALUE;
        WIN32_FIND_DATA wfd;

        hFind = FindFirstFile(szFileName, &wfd);
        if (hFind == INVALID_HANDLE_VALUE) {
          GlobalUnlock(stg.hGlobal);
          ReleaseStgMedium(&stg);
          return E_INVALIDARG;
        }
        FindClose(hFind);
        if (!(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
          fDec = TRUE;
        }
      }
    }
    GlobalUnlock(stg.hGlobal);
    ReleaseStgMedium(&stg);

    HMENU hSubMenu = CreatePopupMenu();
    if (!hSubMenu) return HRESULT_FROM_WIN32(GetLastError());

    InsertMenu(hSubMenu, 0, MF_STRING|MF_BYPOSITION, idCmd++, szSubMenu1);
    if (fDec) {
      InsertMenu(hSubMenu, 1, MF_STRING|MF_BYPOSITION,idCmd++, szSubMenu2);
    }
    InsertMenu(hmenu, indexMenu++, MF_SEPARATOR|MF_BYPOSITION, 0, NULL);

    InsertMenu(hmenu, indexMenu++, MF_STRING | MF_BYPOSITION | MF_POPUP, (UINT_PTR)hSubMenu, szMenu1);
//    InsertMenu(hmenu, indexMenu++, MF_SEPARATOR|MF_BYPOSITION, 0, NULL);

    return (idCmd - idCmdFirst);
  }
  return NOERROR;
}

STDMETHODIMP CShellExtension::InvokeCommand( LPCMINVOKECOMMANDINFO lpcmi )
{
  HRESULT hr = E_INVALIDARG;

  if (!HIWORD(lpcmi->lpVerb)) {
    UINT idCmd = LOWORD(lpcmi->lpVerb);

    switch (idCmd)
    {
      case 0:
        // KageHinata.exe -e basedir [files...]
        {
          FORMATETC fmt = { CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
          STGMEDIUM stg = { TYMED_HGLOBAL };
          HDROP hDrop = NULL;
          UINT i = 0;
          CHAR szBaseDir[MAX_PATH + 1] = "";
          CHAR szJanusHSExe[MAX_PATH + 1] = "";
          CHAR szFileName[MAX_PATH + 1];

          GetModuleFileName(g_hmodThisDll, szJanusHSExe, MAX_PATH);
          *(PathFindFileName(szJanusHSExe)) = '\0';
          lstrcat(szJanusHSExe, "KageHinata.exe");

          if (FAILED(hr = m_pDataObj->GetData(&fmt, &stg)))
            return E_INVALIDARG;

          // HDROP擾
          if (NULL == (hDrop = (HDROP)GlobalLock(stg.hGlobal))) {
            ReleaseStgMedium(&stg);
            hr = HRESULT_FROM_WIN32(GetLastError());
            return hr;
          }

          // t@C`FbN
          UINT uNumFiles = DragQueryFile(hDrop, 0xFFFFFFFF, NULL, 0);
          if (uNumFiles == 0) {
            GlobalUnlock(stg.hGlobal);
            ReleaseStgMedium(&stg);
            return E_INVALIDARG;
          }

          DragQueryFile(hDrop, 0, szBaseDir, MAX_PATH);
          *(PathFindFileName(szBaseDir) - 1) = '\0';
          UINT baselen = ::lstrlen(szBaseDir) + 1;

          /* FIX ME [gtH_łꍇ̏ */

          /* hbvꂽt@C̍ő咷𒲂ׂ */
          UINT totallen = 0, len = 0;
          totallen = lstrlen(szJanusHSExe) + 3 + lstrlen(" -e") + 1 + lstrlen(szBaseDir) + 3;
          for (i = 0; i < uNumFiles; i++) {
            len = DragQueryFile(hDrop, i, NULL, 0);
            if (len < baselen) {
              GlobalUnlock(stg.hGlobal);
              ReleaseStgMedium(&stg);
              return E_INVALIDARG;
            }
            len -= baselen;
            totallen += len + 2 + 1; // DQ  pXy[X
          }
          PSTR pCmdLine = new CHAR[totallen + 1];
          if (!pCmdLine) {
            GlobalUnlock(stg.hGlobal);
            ReleaseStgMedium(&stg);
            return E_OUTOFMEMORY;
          }
          lstrcpy(pCmdLine, "");
          lstrcat(pCmdLine, "\"");
          lstrcat(pCmdLine, szJanusHSExe);
          lstrcat(pCmdLine, "\" -e");
          lstrcat(pCmdLine, " \"");
          lstrcat(pCmdLine, szBaseDir);
          lstrcat(pCmdLine, "\"");
          for (i = 0; i < uNumFiles; i++) {
            DragQueryFile(hDrop, i, szFileName, MAX_PATH);
            lstrcat(pCmdLine, " \"");
            lstrcat(pCmdLine, szFileName + baselen);
            lstrcat(pCmdLine, "\"");
          }
          GlobalUnlock(stg.hGlobal);
          ReleaseStgMedium(&stg);

          {
            STARTUPINFO si;
            PROCESS_INFORMATION pi;
            ZeroMemory(&si, sizeof(si));
            si.cb = sizeof(si);
            ZeroMemory(&pi, sizeof(pi));
            if (!CreateProcess(NULL, pCmdLine, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi)) {
              delete [] pCmdLine;
              return HRESULT_FROM_WIN32(GetLastError());
            }
            CloseHandle(pi.hThread);
            CloseHandle(pi.hProcess);
          }

          delete [] pCmdLine;
          hr = NOERROR;
        }
        break;
      case 1:
        // JanusHS.exe -d filename
        {
          FORMATETC fmt = { CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
          STGMEDIUM stg = { TYMED_HGLOBAL };
          HDROP hDrop;
          UINT i = 0;
          CHAR szJanusHSExe[MAX_PATH + 3 + 2 + MAX_PATH + 3 + 1] = "";
          CHAR szFileName[MAX_PATH + 1] = "";

          GetModuleFileName(g_hmodThisDll, szFileName, MAX_PATH);
          *(PathFindFileName(szFileName)) = '\0';
          lstrcat(szFileName, "KageHinata.exe");
          lstrcpy(szJanusHSExe, "");
          lstrcat(szJanusHSExe, "\"");
          lstrcat(szJanusHSExe, szFileName);
          lstrcat(szJanusHSExe, "\" -d \"");

          if (FAILED(m_pDataObj->GetData(&fmt, &stg)))
            return E_INVALIDARG;

          // HDROP擾
          hDrop = (HDROP)GlobalLock(stg.hGlobal);

          // t@C`FbN
          UINT uNumFiles = DragQueryFile(hDrop, 0xFFFFFFFF, NULL, 0);
          if (uNumFiles != 1) {
            GlobalUnlock(stg.hGlobal);
            ReleaseStgMedium(&stg);
            return E_INVALIDARG;
          }

          DragQueryFile(hDrop, 0, szJanusHSExe + lstrlen(szJanusHSExe), MAX_PATH);
          /* FIX ME [gtH_łꍇ̏ */

          lstrcat(szJanusHSExe, "\"");

          GlobalUnlock(stg.hGlobal);
          ReleaseStgMedium(&stg);

          {
            STARTUPINFO si;
            PROCESS_INFORMATION pi;
            ZeroMemory(&si, sizeof(si));
            si.cb = sizeof(si);
            ZeroMemory(&pi, sizeof(pi));
            if (!CreateProcess(NULL, szJanusHSExe, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi)) {
              return HRESULT_FROM_WIN32(GetLastError());
            }
            CloseHandle(pi.hThread);
            CloseHandle(pi.hProcess);
          }

          hr = NOERROR;
        }
        break;
    }
  }
  return hr;
}

STDMETHODIMP CShellExtension::GetCommandString( UINT idCmd,
                                                UINT uFlags,
                                                UINT *pwReserved,
                                                LPSTR pszName,
                                                UINT cchMax )
{
  return NOERROR;
}

