/**
 * gpgez.h
 * Copyright (C) 2006-2007 Kazuyoshi Kakihara
 *
 * This file is part of KageHinata.
 *
 * KageHinata is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef GPGEZ_H
#define GPGEZ_H

#define DllExport __declspec(dllexport)

#ifdef __cplusplus
extern "C" {
#endif

#define INPUTBOX_WITHCANCEL 1
#define INPUTBOX_SECRET 2
#define INPUTBOX_CONFIRM 4

enum {
  SEVENZIP_ZIPENC,
  SEVENZIP_ZIPENCAES,
  SEVENZIP_7ZENC,
  SEVENZIP_ZIPPLAIN,
  SEVENZIP_7ZPLAIN,
  SEVENZIP_SFX
};

enum {
  TAR_COMPRESS_NONE = 0,
  TAR_COMPRESS_GZIP,
  TAR_COMPRESS_BZIP2
};

enum {
  GPGSTATUS_ALREADY_SIGNED = 1,
  GPGSTATUS_ATTRIBUTE,
  GPGSTATUS_BACKUP_KEY_CREATED,
  GPGSTATUS_BAD_PASSPHRASE,
  GPGSTATUS_BADARMOR,
  GPGSTATUS_BADSIG,
  GPGSTATUS_BEGIN_DECRYPTION,
  GPGSTATUS_BEGIN_ENCRYPTION,
  GPGSTATUS_BEGIN_STREAM,
  GPGSTATUS_CARDCTRL,
  GPGSTATUS_DECRYPTION_FAILED,
  GPGSTATUS_DECRYPTION_OKAY,
  GPGSTATUS_DELETE_PROBLEM,
  GPGSTATUS_ENC_TO,
  GPGSTATUS_END_DECRYPTION,
  GPGSTATUS_END_ENCRYPTION,
  GPGSTATUS_END_STREAM,
  GPGSTATUS_ERROR,
  GPGSTATUS_ERRSIG,
  GPGSTATUS_EXPKEYSIG,
  GPGSTATUS_EXPSIG,
  GPGSTATUS_FILE_DONE,
  GPGSTATUS_FILE_START,
  GPGSTATUS_GET_BOOL,
  GPGSTATUS_GET_HIDDEN,
  GPGSTATUS_GET_LINE,
  GPGSTATUS_GOOD_PASSPHRASE,
  GPGSTATUS_GOODSIG,
  GPGSTATUS_GOT_IT,
  GPGSTATUS_IMPORT_CHECK,
  GPGSTATUS_IMPORT_OK,
  GPGSTATUS_IMPORT_PROBLEM,
  GPGSTATUS_IMPORT_RES,
  GPGSTATUS_IMPORTED,
  GPGSTATUS_INV_RECP,
  GPGSTATUS_KEY_CREATED,
  GPGSTATUS_KEY_NOT_CREATED,
  GPGSTATUS_KEYEXPIRED,
  GPGSTATUS_KEYREVOKED,
  GPGSTATUS_MISSING_PASSPHRASE,
  GPGSTATUS_NEED_PASSPHRASE,
  GPGSTATUS_NEED_PASSPHRASE_PIN,
  GPGSTATUS_NEED_PASSPHRASE_SYM,
  GPGSTATUS_NEWSIG,
  GPGSTATUS_NO_PUBKEY,
  GPGSTATUS_NO_RECP,
  GPGSTATUS_NO_SECKEY,
  GPGSTATUS_NODATA,
  GPGSTATUS_NOTATION_DATA,
  GPGSTATUS_NOTATION_NAME,
  GPGSTATUS_PLAINTEXT,
  GPGSTATUS_PLAINTEXT_LENGTH,
  GPGSTATUS_POLICY_URL,
  GPGSTATUS_PROGRESS,
  GPGSTATUS_REVKEYSIG,
  GPGSTATUS_RSA_OR_IDEA,
  GPGSTATUS_SC_OP_FAILURE,
  GPGSTATUS_SC_OP_SUCCESS,
  GPGSTATUS_SESSION_KEY,
  GPGSTATUS_SHM_GET,
  GPGSTATUS_SHM_GET_BOOL,
  GPGSTATUS_SHM_GET_HIDDEN,
  GPGSTATUS_SHM_INFO,
  GPGSTATUS_SIG_CREATED,
  GPGSTATUS_SIG_ID,
  GPGSTATUS_SIG_SUBPACKET,
  GPGSTATUS_SIGEXPIRED,
  GPGSTATUS_TRUNCATED,
  GPGSTATUS_TRUST_FULLY,
  GPGSTATUS_TRUST_MARGINAL,
  GPGSTATUS_TRUST_NEVER,
  GPGSTATUS_TRUST_ULTIMATE,
  GPGSTATUS_TRUST_UNDEFINED,
  GPGSTATUS_UNEXPECTED,
  GPGSTATUS_USERID_HINT,
  GPGSTATUS_VALIDSIG,
  GPGSTATUS_ZZZZZZZZ
};

/*
 * DllExport DWORD ValidateNameForGpg(PCSTR szName)
 *
 * Tv
 * szNameGnuPG̃[U[IDNameƂēKȏmF
 *
 * ߂l
 * 0: 
 * 1: OZ
 * 2: sȕ܂܂Ă
 */
DllExport DWORD ValidateNameForGpg(PCSTR szName);

/*
 * DllExport DWORD ValidateEmailForGpg(PCSTR szEmail)
 *
 * Tv
 * szEmailGnuPG̃[U[IDEmail AddressƂēKȏmF
 *
 * ߂l
 * 0: 
 * 1: sȌ`
 * 2: sȕ܂܂Ă
 */
DllExport DWORD ValidateEmailForGpg(PCSTR szEmail);

/*
 * DllExport DWORD ValidateCommentForGpg(PCSTR szComment)
 *
 * Tv
 * szCommentGnuPG̃[U[IDCommentƂēKȏmF
 *
 * ߂l
 * 0: 
 * 2: sȕ܂܂Ă
 */
DllExport DWORD ValidateCommentForGpg(PCSTR szComment);

/*
 * DllExport HRESULT GetNameFromGpgId(PCSTR pGpgId, PSTR pName, DWORD dwMax);
 *
 * Tv
 * GnuPG̃[U[IDName𒊏oApNameɃRs[
 *
 */
DllExport HRESULT GetNameFromGpgId(PCSTR pGpgId, PSTR pName, DWORD dwMax);

/*
 * DllExport HRESULT GetEmailFromGpgId(PCSTR pGpgId, PSTR pEmail, DWORD dwMax);
 *
 * Tv
 * GnuPG̃[U[IDEmail𒊏oApEmailɃRs[
 *
 */
DllExport HRESULT GetEmailFromGpgId(PCSTR pGpgId, PSTR pEmail, DWORD dwMax);

/*
 * DllExport HRESULT GetCommentFromGpgId(PCSTR pGpgId, PSTR pComment, DWORD dwMax, PCSTR pGpgId);
 *
 * Tv
 * GnuPG̃[U[IDComment𒊏oApCommentɃRs[
 *
 */
DllExport HRESULT GetCommentFromGpgId(PCSTR pGpgId, PSTR pComment, DWORD dwMax);

/*
 * DllExport VOID gpgez_setstatuslog(PCSTR pFileName);
 *
 * Tv
 * pFileNameɃfobOp̃O
 *
 */
DllExport VOID gpgez_setstatuslog(PCSTR pFileName);

/*
 * DllExport HRESULT gpgez_open_file_inherit_read(PHANDLE ph, PCSTR pFileName);
 *
 * Tv
 * pFileNamep̏ԂœǂݎI[v
 *
 */
DllExport HRESULT gpgez_open_file_inherit_read(PHANDLE ph, PCSTR pFileName);

/*
 * DllExport HRESULT gpgez_open_file_inherit_write(PHANDLE ph, PCSTR pFileName);
 *
 * Tv
 * pFileNamep̏Ԃŏ݃I[v
 *
 */
DllExport HRESULT gpgez_open_file_inherit_write(PHANDLE ph, PCSTR pFileName);

/*
 * DllExport INT gpgez_interpert_status(PCSTR pStatusStr);
 *
 * Tv
 * gpgstatus outputStatusStrenumꂽl̃Xe[^Xɕϊ
 *
 */
DllExport INT gpgez_interpret_status(PCSTR pStatusStr);

/*
 * ǧw擾֐
 *
 */
DllExport HRESULT gpgez_loadmyfpr(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, PSTR *ppFpr);

/*
 * p̊֐
 *
 */
typedef struct struct_gpgez_genkey *PGPGEZ_GENKEY;
DllExport HRESULT gpgez_genkey_create(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                      HANDLE hStatusW, PGPGEZ_GENKEY *ppgpgez_genkey);
DllExport HRESULT gpgez_genkey_release(PGPGEZ_GENKEY *ppgpgez_genkey);
DllExport HANDLE gpgez_genkey_get_process_handle(PGPGEZ_GENKEY pgpgez_genkey);
DllExport HRESULT gpgez_genkey_write_param(PGPGEZ_GENKEY pgpgez_genkey, PCSTR pkey, PCSTR pval);
DllExport HRESULT gpgez_genkey_write_cmd(PGPGEZ_GENKEY pgpgez_genkey, PCSTR pcmd);
DllExport HRESULT gpgez_genkey_close_write(PGPGEZ_GENKEY pgpgez_genkey);
DllExport HRESULT gpgez_genkey_finish(PGPGEZ_GENKEY pgpgez_genkey);
DllExport INT gpgez_genkey_get_exitcode(PGPGEZ_GENKEY pgpgez_genkey);
//DllExport HRESULT gpgez_genkey(HWND hwnd, PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, PCSTR pName, PCSTR pEMail, PCSTR pComment, PCSTR pPassphrase, PSTR *ppFpr, PHANDLE *pphProcess, DWORD (*ShowMessage)(HWND hwnd, PCSTR pmsg));

/*
 * gpgpėp֐
 *
 */
typedef struct struct_gpgez_gpg *PGPGEZ_GPG;
DllExport HRESULT gpgez_gpg_release(PGPGEZ_GPG *ppgpgez_gpg);
DllExport HANDLE gpgez_gpg_get_process_handle(PGPGEZ_GPG pgpgez_gpg);
DllExport HRESULT gpgez_gpg_finish(PGPGEZ_GPG pgpgez_gpg);
DllExport INT gpgez_gpg_get_exitcode(PGPGEZ_GPG pgpgez_gpg);
DllExport PSTRINGLIST gpgez_gpg_get_statuslist(PGPGEZ_GPG pgpgez_gpg);

/* gpgÍp̊֐ */
DllExport HRESULT gpgez_gpg_create_encrypt(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                       BOOL fNoDefaultKeyRing, PSTRINGLIST pslRecipients, PCSTR pPassphrase,
                                       BOOL fSign, BOOL fAscii, PCSTR pFileName,
                                       HANDLE hIn, HANDLE hOut, HANDLE hErr, PGPGEZ_GPG *ppgpgez_encrypt);
/* gpgp̊֐ */
DllExport HRESULT gpgez_gpg_create_decrypt(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                       BOOL fNoDefaultKeyring, BOOL fSkipVerify, PCSTR pPassphrase,
                                       HANDLE hIn, HANDLE hOut, HANDLE hErr, PGPGEZ_GPG *ppgpgez_decrypt);
/* gpgeXgp̊֐ */
DllExport HRESULT gpgez_gpg_create_decrypt_listonly(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                  BOOL fNoDefaultKeyRing, PCSTR pPassphrase, 
                                  HANDLE hIn, HANDLE hOut, HANDLE hErr, PGPGEZ_GPG *ppgpgez_decrypt);
/* gpgC|[gp̊֐ */
DllExport HRESULT gpgez_gpg_create_import(PCSTR pGpgExe, PCSTR pGpgHome,
                                      PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                      BOOL fNoDefaultKeyring, HANDLE hIn,
                                      HANDLE hErr, PGPGEZ_GPG *ppgpgez_import);

/* gpgGNX|[gp̊֐ */
DllExport HRESULT gpgez_gpg_create_export(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                      BOOL fNoDefaultKeyring, PCSTR pFpr, BOOL fAscii,
                                      HANDLE hOut, HANDLE hErr, PGPGEZ_GPG *ppgpgez_export);
/* gpg폜p̊֐ */
DllExport HRESULT gpgez_gpg_create_deletekey(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                      BOOL fNoDefaultKeyRing, PCSTR pFpr, HANDLE hErr, PGPGEZ_GPG *ppgpgez_delete);
/* gpgp̊֐ */
DllExport HRESULT gpgez_gpg_create_sign(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                     BOOL fNoDefaultKeyRing, PCSTR pPassphrase, BOOL fAscii, BOOL fDetach,
                     HANDLE hIn, HANDLE hOut, HANDLE hErr, PGPGEZ_GPG *ppgpgez_sign);
/* gpgؗp̊֐ */
DllExport HRESULT gpgez_gpg_create_verify(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                     BOOL fNoDefaultKeyRing, PCSTR pPassphrase, PCSTR pSignFileName,
                     HANDLE hIn, HANDLE hErr, PGPGEZ_GPG *ppgpgez_verify);
/* Ascii Armorp̊֐ */
DllExport HRESULT gpgez_gpg_create_armor(PCSTR pGpgExe, PCSTR pGpgHome, BOOL fEnArmor,
                                         HANDLE hIn, HANDLE hOut, HANDLE hErr, PGPGEZ_GPG *ppgpgez_armor);

/*
 * gpg --edit-keyp֐
 *
 */
typedef struct struct_gpgez_gpg_editkey *PGPGEZ_GPG_EDITKEY;
DllExport HRESULT gpgez_gpg_editkey_create(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                         BOOL fNoDefaultKeyRing, PCSTR pFpr,
                         PGPGEZ_GPG_EDITKEY *ppgpg);
DllExport HRESULT gpgez_gpg_editkey_release(PGPGEZ_GPG_EDITKEY *ppgpgez_gpg_editkey);
DllExport HRESULT gpgez_gpg_editkey_write_command(PGPGEZ_GPG_EDITKEY pgpg, PCSTR pstr);
DllExport HRESULT gpgez_gpg_editkey_wait_write_command(PGPGEZ_GPG_EDITKEY pgpg, INT iStatus, PCSTR pHint, PCSTR pstr);
DllExport HRESULT gpgez_gpg_editkey_finish(PGPGEZ_GPG_EDITKEY pgpg);

/*
 * ̑ėp֐
 *
 */
typedef struct struct_gpgez_cmd *PGPGEZ_CMD;
DllExport HRESULT gpgez_cmd_release(PGPGEZ_CMD *ppgpgez_cmd);
DllExport HANDLE gpgez_cmd_get_process_handle(PGPGEZ_CMD pgpgez_cmd);
DllExport HRESULT gpgez_cmd_finish(PGPGEZ_CMD pgpgez_CMD);
DllExport INT gpgez_cmd_get_exitcode(PGPGEZ_CMD pgpgez_cmd);

/*
 * tarA[JCup̊֐
 *
 */
DllExport HRESULT gpgez_tar_create(PCSTR pTarExe, INT iCompressMode, PCSTR pBaseDirectory, PSTRINGLIST pslFiles,
                                   HANDLE hOut, HANDLE hErr, 
                                   PGPGEZ_CMD *ppgpgez_tar);

/*
 * 7zipA[JCup̊֐
 *
 */
DllExport HRESULT gpgez_sevenzip_create(PCSTR pSevenZipExe, INT iCompressMode, PCSTR pBaseDirectory, PSTRINGLIST pslFiles,
                                        PCSTR pPassphrase, PCSTR pZFileName, HANDLE hErr,
                                        PGPGEZ_CMD *ppgpgez_sevenzip);


/*
 * tarWJp̊֐
 *
 */
DllExport HRESULT gpgez_untar_create(PCSTR pTarExe, PCSTR pBaseDirectory, BOOL fOverWrite,
                                     HANDLE hIn, HANDLE hErr,
                                     PGPGEZ_CMD *ppgpgez_untar);

/*
 * tareXgp̊֐
 *
 */
DllExport HRESULT gpgez_testtar_create(PCSTR pTarExe, HANDLE hIn, HANDLE hErr, PGPGEZ_CMD *ppgpgez_testtar);

/*
 * 7zipWJp̊֐
 *
 */
DllExport HRESULT gpgez_unsevenzip_create(PCSTR pSevenZipExe, PCSTR pFileName, PCSTR pBaseDirectory,
                                          BOOL fOverWrite, PCSTR pPassphrase, HANDLE hErr,
                                          PGPGEZ_CMD *ppgpgez_unsevenzip);

/*
 * 7zipWJp̊֐(gzipWJp)
 *
 */
DllExport HRESULT gpgez_unsevenzipunzip_create(PCSTR pSevenZipExe, PCSTR pFileNameIn, HANDLE hOut,
                             HANDLE hErr, PGPGEZ_CMD *ppgpgez_unsevenzipunzip);


/*
 * nkfp̊֐
 *
 */
DllExport HRESULT gpgez_nkf_create(PCSTR pNkfExe, PCSTR pCodeSetIn, PCSTR pCodeSetOut,
                 HANDLE hIn, HANDLE hOut, HANDLE hErr, PGPGEZ_CMD *ppgpgez_nkf);
/*
 * O̊mFp֐
 *
 */
DllExport HRESULT gpgez_ispublicencrypted(PCSTR pGpgExe, PCSTR pGpgHome,
                                          PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                          PCSTR pFilename, PBOOL pfPublic);
DllExport HRESULT gpgez_ispublicencrypted_buff(PCSTR pGpgExe, PCSTR pGpgHome,
                                               PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                               PCSTR pbuff, DWORD dwLen, PBOOL pfPublic);
DllExport HRESULT gpgez_isdecryptverified(PCSTR pGpgExe, PCSTR pTarExe, PCSTR pGpgHome,
                                          PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                          PCSTR pPassphrase, PCSTR pFilename,
                                          PSTRINGLIST pslVerifiedName, PSTRINGLIST pslVerifiedFpr,
                                          PSTR pXFilename, DWORD dwLen, PDWORD pdwSize, PBOOL pfTar);
DllExport HRESULT gpgez_is7zencrypted(PCSTR p7ZipExe, PCSTR pFileName, PBOOL pfEncrypted);

/*
 * gpgR}hQ
 *
 */
#if 0
DllExport HRESULT gpgez_encrypt(PCSTR pGpgExe, PCSTR pGpgHome,
                                PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                PCSTR pFile, PCSTR pZfile, PSTRINGLIST pRecipients,
                                PCSTR pPassphraseSym, BOOL fSign, BOOL fAscii);
DllExport HRESULT gpgez_encryptfrombuff(PCSTR pGpgExe, PCSTR pGpgHome,
                                        PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                        PCSTR pBuff, DWORD dwLen, PCSTR pZfile, PSTRINGLIST pRecipients,
                                        PCSTR pPassphraseSym, BOOL fSign, BOOL fAscii);
DllExport HRESULT gpgez_encrypt_buff2buff(PCSTR pGpgExe, PCSTR pGpgHome,
                                          PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                          PCSTR pbuff, DWORD dwLen, PSTR *ppBuff, PDWORD pdwLen,
                                          PSTRINGLIST pRecipients, PCSTR pPassphraseSym,
                                          BOOL fSign, BOOL fAscii);
DllExport HRESULT gpgez_tarencrypt(PCSTR pTarExe, PCSTR pGpgExe, PCSTR pGpgHome,
                                   PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                   PCSTR pBaseDirectory, PSTRINGLIST pFiles, PCSTR pZfile,
                                   PSTRINGLIST pRecipients, PCSTR pPassphraseSym,
                                   BOOL fSign, BOOL fAscii);
DllExport HRESULT gpgez_zipencrypt(PCSTR p7ZipExe, PCSTR pBaseDirectory, PSTRINGLIST pFiles,
                                   PCSTR pZfile, PCSTR pPassphraseSym);
DllExport HRESULT gpgez_7zencrypt(PCSTR p7ZipExe, PCSTR pBaseDirectory, PSTRINGLIST pFiles,
                                  PCSTR pZfile, PCSTR pPassphraseSym, INT iMode);
DllExport HRESULT gpgez_tar(PCSTR pTarExe, PCSTR pBaseDirectory, PSTRINGLIST pFiles,
                            PCSTR pZfile, INT iMode);
DllExport HRESULT gpgez_encryptsfx(PCSTR p7ZipExe, PCSTR pBaseDirectory, PSTRINGLIST pFiles,
                                   PCSTR pZfile, PCSTR pPassphraseSym);
DllExport HRESULT gpgez_decrypt(PCSTR pGpgExe, PCSTR pGpgHome,
                                PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                PCSTR pPassphrase, PCSTR pFile, PCSTR pXFile);
DllExport HRESULT gpgez_decrypt2buff(PCSTR pGpgExe, PCSTR pGpgHome,
                                     PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                     PCSTR pPassphrase, PCSTR pFile, PSTR *ppbuff, PDWORD pdwLen);
DllExport HRESULT gpgez_decrypt_buff2buff(PCSTR pGpgExe, PCSTR pGpgHome,
                                          PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                          PCSTR pPassphrase, PCSTR pbuff, DWORD dwLen,
                                          PSTR *ppbuff, PDWORD pdwLen, PSTRINGLIST pslVerified);
DllExport HRESULT gpgez_decrypttar(PCSTR pGpgExe, PCSTR pTarExe, PCSTR pGpgHome,
                                   PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing,
                                   PCSTR pPassphrase, PCSTR pFileName, PCSTR pBaseDirectory, BOOL fOverWrite);
DllExport HRESULT gpgez_7zdecrypt(PCSTR p7ZipExe, PCSTR pPassphrase,
                                  PCSTR pFileName, PCSTR pBaseDirectory, BOOL fOverWrite);
DllExport HRESULT gpgez_untar(PCSTR pTarExe, PCSTR pFileName, PCSTR pBaseDirectory, BOOL fOverWrite);
DllExport HRESULT gpgez_7zgunzip(PCSTR p7ZipExe, PCSTR pFileNameIn, PCSTR pFileNameOut);
#endif
DllExport HRESULT gpgez_changeuserid(PCSTR pGpgExe, PCSTR pGpgHome,
                                     PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, PCSTR pFpr,
                                     PCSTR pName, PCSTR pEmail, PCSTR pComment, PCSTR pPassphrase);
DllExport HRESULT gpgez_changepassphrase(PCSTR pGpgExe, PCSTR pGpgHome,
                                         PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, PCSTR pFpr,
                                         PCSTR pOldPass, PCSTR pNewPass);
#if 0
DllExport HRESULT gpgez_import(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, BOOL fNoDefault, PCSTR pFileName);
DllExport HRESULT gpgez_export(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, PCSTR pFpr, PCSTR pFileName, BOOL fAscii);
DllExport HRESULT gpgez_delete(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, BOOL fNoDefault, PCSTR pFpr);
DllExport HRESULT gpgez_detach_sign(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, PCSTR pFile, PCSTR pSfile, PCSTR pPassphraseSym, BOOL fAscii);
DllExport HRESULT gpgez_verify(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, PCSTR pFile, PCSTR pSfile, PCSTR pPassphraseSym);
DllExport HRESULT gpgez_armor(PCSTR pGpgExe, PCSTR pGpgHome, PCSTR pFileNameIn, PCSTR pFileNameOut, BOOL fEnArmor);
#endif
/* create_stringlist(pKeys) ĂĂяoƁApKeyslist-key̌ʂԂ */
DllExport HRESULT gpgez_listkeys(PCSTR pGpgExe, PCSTR pGpgHome, PSTRINGLIST pslSecRing, PSTRINGLIST pslPubRing, BOOL fNoDefaultKeyRing, BOOL fSec, PSTRINGLIST pKeys);


/* ̑֐ */
DllExport HRESULT gpgez_ReadFileLine(PREADFILEBUFF pfile, PSTR buff, DWORD len, PCSTR pLine);
DllExport VOID unescapeTarMessage(PSTR pLine);
DllExport VOID unescapePercent(PCSTR ps, PSTR pd, DWORD dwLen);

#ifdef __cplusplus
}
#endif

#endif
