#ifndef UTIL_H
#define UTIL_H

#define DllExport __declspec(dllexport)

#include "../include/util_binbuff.h"
#include "../include/util_string.h"
#include "../include/util_stringlist.h"
#include "../include/util_target_filelist.h"
#include "../include/util_readfilebuff.h"
#include "../include/util_cmdez.h"
#include "../include/util_readfilebuff.h"

#ifdef __cplusplus
extern "C" {
#endif

#define HANDLE_DLG_MSG(hwnd, msg, fn) \
    case(msg): \
        return SetDlgMsgResult(hwnd, msg, HANDLE_##msg(hwnd, wParam, lParam, fn)) 

/* debugging */
DllExport VOID InitDebugError(PSTR pLogFileName);
DllExport VOID ResetDebugError(VOID);
DllExport VOID DebugError(INT level, HRESULT hr, PCSTR filename, INT line);

/* utils */
DllExport HRESULT CloseHandleClean(PHANDLE ph);
DllExport HRESULT util_create_write_pipe(PHANDLE phWrite, PHANDLE phRead);
DllExport HRESULT util_create_read_pipe(PHANDLE phRead, PHANDLE phWrite);
DllExport HRESULT WriteFileLine1(HANDLE hFile, PCSTR s1);

#define UTIL_MAX_CHAR_BUFF 65535
DllExport PVOID util_malloc(DWORD dwBytes);
DllExport VOID util_free(PVOID memblock);
DllExport INT util_atoi(PCSTR str);
DllExport PCSTR util_strchr(PCSTR s, WORD c);
DllExport PSTR util_strdup(PCSTR s);
DllExport PSTR util_strndup(PCSTR s, INT len);
DllExport INT util_strlen(PCSTR s, INT max);
DllExport HRESULT util_strcpy(PSTR dst, INT max, PCSTR src);
DllExport HRESULT util_strncpy(PSTR dst, INT max, PCSTR src, INT len);
DllExport HRESULT util_strcat(PSTR dst, INT max, PCSTR src);
DllExport INT util_strcmp(PCSTR s1, PCSTR s2);
DllExport INT util_stricmp(PCSTR s1, PCSTR s2);
DllExport INT util_strncmp(PCSTR s1, PCSTR s2, INT len);
DllExport INT util_strnicmp(PCSTR s1, PCSTR s2, INT len);
DllExport INT util_strncmpl(PCSTR s1, PCSTR s2);
DllExport PSTR enclose_dq(PCSTR src);
DllExport PSTR push_dh(PCSTR src);
DllExport PSTR util_itoa(INT i, PSTR buff, INT max);
DllExport HRESULT sv_get(PCSTR src, CHAR sep, DWORD pos, PSTR dst, DWORD len);
DllExport PCSTR sv_pos(PCSTR src, CHAR sep, DWORD pos);
DllExport BOOL sv_cmp(PCSTR src, CHAR sep, DWORD pos, PCSTR pcmp);

DllExport HRESULT util_createfolder(PCSTR folder);

DllExport PSTR util_pathfindextension(PSTR pFileName);

DllExport HRESULT util_sjistoutf8(PCSTR pSjis, PSTR *ppUtf8);
DllExport HRESULT util_utf8tosjis(PCSTR pUtf8, PSTR *ppSjis);
DllExport HRESULT util_lftocrlf(PCSTR pSrc, PSTR *ppDst);

DllExport HRESULT util_is_file_included_in_a_folder(PCSTR pFileName, PTARGET_FILELIST ptfl, PBOOL pbRet);

#define DEBUGLEVEL 1
#ifdef THISFILENAME
#define DEBUGERROR(c, d) DebugError(c, d, THISFILENAME, __LINE__)
#else
#define DEBUGERROR(c, d) DebugError(c, d, __FILE__, __LINE__)
#endif

#ifdef __cplusplus
}
#endif

#endif /* UTIL_H */