#ifndef UTIL_CMDEZ_H
#define UTIL_CMDEZ_H

#define DllExport __declspec(dllexport)

#ifdef __cplusplus
extern "C" {
#endif

enum {
  HANDLE_TYPE_STDIN,
  HANDLE_TYPE_STDOUT,
  HANDLE_TYPE_STDERR
};

typedef struct struct_cmd_option_node *PCMDOPTION_NODE;
typedef struct struct_cmd_option *PCMDOPTION;
typedef struct struct_cmdez_context *PCMDEZCONTEXT;

DllExport HRESULT cmdez_initialize(PCMDEZCONTEXT *ppctx, PCSTR cmdexe, PCSTR currentdir);
DllExport HRESULT cmdez_release(PCMDEZCONTEXT *ppctx);
DllExport HRESULT cmdez_add_option(PCMDEZCONTEXT pctx, PCSTR option, PCSTR value, BOOL fDq);
DllExport HRESULT cmdez_add_option2(PCMDEZCONTEXT pctx, PCSTR option, PCSTR value, PCSTR opr, BOOL fDq);
DllExport HRESULT cmdez_add_operand(PCMDEZCONTEXT pctx, PCSTR value, BOOL fDq);
DllExport HRESULT cmdez_set_handle(PCMDEZCONTEXT pctx, INT type, HANDLE h);
DllExport HRESULT cmdez_execute(PCMDEZCONTEXT pctx);
DllExport PHANDLE cmdez_get_pprocess(PCMDEZCONTEXT pctx);
DllExport HANDLE cmdez_get_process(PCMDEZCONTEXT pctx);
DllExport DWORD cmdez_get_exitcode(PCMDEZCONTEXT pctx);
DllExport HRESULT cmdez_finish(PCMDEZCONTEXT pctx);

#ifdef __cplusplus
}
#endif

#endif /* UTIL_CMDEZ_H */