#ifndef UTIL_STRINGLIST_H
#define UTIL_STRINGLIST_H

#define DllExport __declspec(dllexport)

#ifdef __cplusplus
extern "C" {
#endif

/* stringlist */
typedef struct struct_stringlist_node *PSTRINGLIST_NODE;
#ifndef PSTRINGLIST_DEF
#define PSTRINGLIST_DEF
typedef struct struct_stringlist *PSTRINGLIST;
#endif

DllExport HRESULT stringlist_create(PSTRINGLIST *pplist);
DllExport HRESULT stringlist_release(PSTRINGLIST *pplist);
DllExport HRESULT stringlist_add_node(PSTRINGLIST plist, PCSTR pstr);
DllExport HRESULT stringlist_add_node_len(PSTRINGLIST plist, PCSTR pstr, int len);
DllExport HRESULT stringlist_concat(PSTRINGLIST plist, PSTRINGLIST plist2add);
DllExport PCSTR *stringlist_get_table(PSTRINGLIST plist);
DllExport PSTRINGLIST_NODE stringlist_get_head(PSTRINGLIST plist);
DllExport PSTRINGLIST_NODE stringlist_get_next(PSTRINGLIST_NODE pnode);
DllExport PCSTR stringlist_get_string(PSTRINGLIST_NODE pnode);
DllExport stringlist_get_len(PSTRINGLIST plist);


#ifdef __cplusplus
}
#endif

#endif /* UTIL_STRINGLIST_H */