#define THISFILENAME "util/util_binbuff.c"

#include <windows.h>
#include "../include/util.h"
 
typedef struct struct_binbuff {
  PVOID buff;
  DWORD max;
  DWORD len;
} BINBUFF;

#ifdef BINBUFF_BUFF_LEN_BASE
#undef BINBUFF_BUFF_LEN_BASE
#endif
#define BINBUFF_BUFF_LEN_BASE 1024

/*------------------------------------------------------------*/
DllExport HRESULT
binbuff_create(PBINBUFF *ppbinbuff) {
  HRESULT hr = S_OK;

  if (*ppbinbuff) {
    hr = HRESULT_FROM_WIN32(ERROR_INVALID_DATA);
    goto finish_func;
  }
  *ppbinbuff = (PBINBUFF)util_malloc(sizeof(BINBUFF));
  if (!*ppbinbuff) {
    hr = HRESULT_FROM_WIN32(ERROR_OUTOFMEMORY);
    goto finish_func;
  }
  (*ppbinbuff)->buff = NULL;
  (*ppbinbuff)->max = 0;
  (*ppbinbuff)->len = 0;
finish_func:
  return hr;
}

/*------------------------------------------------------------*/
DllExport HRESULT
binbuff_append(PBINBUFF pbinbuff, PVOID pbuff, DWORD len) {
  HRESULT hr = S_OK;

  /* obt@Ȃꍇ̓[mۂȂ */
  if (pbinbuff->len + len >= pbinbuff->max) {
    DWORD max = 0;
    PSTR buff2;
    
    max = (pbinbuff->max > BINBUFF_BUFF_LEN_BASE) ? pbinbuff->max : BINBUFF_BUFF_LEN_BASE;
    while (max < pbinbuff->len + len) max *= 2;
    buff2 = (PVOID)util_malloc(max + 1);
    if (!buff2) {
      hr = HRESULT_FROM_WIN32(ERROR_OUTOFMEMORY);
      goto finish_func;
    }
    if (pbinbuff->buff) {
      CopyMemory(buff2, pbinbuff->buff, pbinbuff->len);
      util_free(pbinbuff->buff);
    }
    pbinbuff->buff = buff2;
    pbinbuff->max = max;
  }

  /* f[^ǉ */
  CopyMemory((PBYTE)(pbinbuff->buff) + pbinbuff->len, pbuff, len);
  pbinbuff->len += len;

finish_func:
  return hr;
}

/*------------------------------------------------------------*/
DllExport PCSTR
binbuff_buff(PBINBUFF pbinbuff) {
  return pbinbuff->buff;
}

/*------------------------------------------------------------*/
DllExport DWORD
binbuff_len(PBINBUFF pbinbuff) {
  return pbinbuff->len;
}

/*------------------------------------------------------------*/
DllExport PVOID
binbuff_detach(PBINBUFF pbinbuff) {
  PSTR p = pbinbuff->buff;
  pbinbuff->buff = NULL;
  pbinbuff->len = 0;
  pbinbuff->max = 0;
  return p;
}

/*------------------------------------------------------------*/
DllExport HRESULT
binbuff_release(PBINBUFF *ppbinbuff) {
  if (*ppbinbuff) {
    if ((*ppbinbuff)->buff) util_free((*ppbinbuff)->buff);
    util_free(*ppbinbuff);
  }
  *ppbinbuff = NULL;
  return S_OK;
}

/*------------------------------------------------------------*/
