#define THISFILENAME "util/util_target_filelist.c"

#include <windows.h>
#include "../include/util.h"

typedef struct struct_target_filelist {
  PSTR basedir; /* t@CQ̐efBNg(\܂܂) */
  PSTRINGLIST files;
} TARGET_FILELIST;

/*------------------------------------------------------------*/
DllExport HRESULT
target_filelist_create(PTARGET_FILELIST *pplist, PCSTR basedir) {
  HRESULT hr = S_OK;

  if (*pplist) {
    hr = HRESULT_FROM_WIN32(ERROR_INVALID_FUNCTION);
    goto finish_func;
  }
  *pplist = (PTARGET_FILELIST)util_malloc(sizeof(TARGET_FILELIST));
  if (!*pplist) {
    hr = HRESULT_FROM_WIN32(ERROR_OUTOFMEMORY);
    goto finish_func;
  }
  (*pplist)->basedir = NULL;
  (*pplist)->files = NULL;
  if (!((*pplist)->basedir = util_strdup(basedir))) {
    hr = HRESULT_FROM_WIN32(ERROR_OUTOFMEMORY);
    util_free(*pplist);
    *pplist = NULL;
    goto finish_func;
  }
  if (FAILED(hr = stringlist_create(&((*pplist)->files)))) {
    util_free((*pplist)->basedir);
    util_free(*pplist);
    *pplist = NULL;
    goto finish_func;
  }
finish_func:
  return hr;
}

/*------------------------------------------------------------*/
DllExport HRESULT
target_filelist_release(PTARGET_FILELIST *pplist) {
  HRESULT hr = S_OK;

  if (!*pplist) {
    hr = HRESULT_FROM_WIN32(ERROR_INVALID_FUNCTION);
    goto finish_func;
  }
  if ((*pplist)->basedir) util_free((*pplist)->basedir);
  if ((*pplist)->files) stringlist_release(&(*pplist)->files);
finish_func:
  return hr;
}

/*------------------------------------------------------------*/
DllExport HRESULT
target_filelist_add_node(PTARGET_FILELIST plist, PCSTR pstr) {
  return stringlist_add_node(plist->files, pstr);
}

/*------------------------------------------------------------*/
DllExport PCSTR
target_filelist_get_basedir(PTARGET_FILELIST plist) {
  return plist->basedir;
}

/*------------------------------------------------------------*/
DllExport PSTRINGLIST
target_filelist_get_files(PTARGET_FILELIST plist) {
  return plist->files;
}

/*------------------------------------------------------------*/
DllExport DWORD
target_filelist_get_number_of_files(PTARGET_FILELIST plist) {
  return stringlist_get_len(plist->files);
}

/*------------------------------------------------------------*/
